% Compute multiplication table Mj
%    j = coordinate
%    P = H-basis
%    LP = Leading terms of P
%    dP = degrees of P
%    N = Homogeneous orthogonal basis of normal form space
%    dN = degree
%    s = #variables


function Mj = MjComp( j,P,LP,dP,N,dN,s )
  Mj = [];
  Ndeg = max( dN );

  lastcol = 0;

  for k=0:Ndeg
    fdeg = bincoeff( k+s,s );
    fdeg1 = bincoeff( k+s+1,s );
    ai = find( dN == k );

    NN = LjMat( s,k,j ) * N ( 1:fdeg,ai );
    NN = NN( fdeg+1:fdeg1,: );

    R = Reduce( P,LP,dP,NN,k+1,s );

    % build the matrix

    A = [];
    klim = min( k+1,Ndeg );
    for l=0:klim
      al = find( dN == l );
      A = [ A ; N( bincoeff( l+s-1,s)+1:bincoeff(l+s,s),al )' * R{l+1} ];
    end
    [ Am, An ] = size( A );
    A = [ A ; zeros( length(dN)-Am , An ) ];

    Mj = [ Mj, A ];
  end
end

