% Pronys method to
%   f = function
%   n = estimate for deg R
%   s = #Variables

function [ fom,Om ] = Prony( n,s )
  % Compute decomposition
  [ F,K,LK,N,dK,dN ] = Prony1( n,s );

  Rdim = length( dN );
  Rdeg = max( dN );
  MeigVals = zeros( s, Rdim );

  % Compute multiplication tables
  [ V1,E1 ] = eig( MjComp( 1,K,LK,dK,N,dN,s ) );
  MeigVals( 1,: ) = diag( E1 )';

  for j=2:s
    [ Vj,Ej ] = eig( MjComp( j,K,LK,dK,N,dN,s ) );
    % X = V1' * Vj;
    % [a,b] = max( abs( X ) );
    % P = zeros( Rdim );
    % for l=1:Rdim
    %   P (l,b(l) ) = 1;
    % end
    P = ( abs( V1 \ Vj ) > .5 );
    MeigVals( j,: ) = (P * diag( Ej ))';
  end
  
  % Frequencies are found
  Om = log( MeigVals );

  %---------------------------------------

  % Compute Vandermonde matrix
  
  A = MultIndices( s,Rdeg );
  [ Am,An ] = size( A );
  V = zeros( Rdim,An );

  for j=1:Rdim
    V( j,: ) = exp( Om( :,j )' * A );
  end
  
  %printf( "\tVCond = %f\n", cond(V) );

  fom = ( V' \ FnkFunc( Rdeg,0 ) )';
end
