% Vandermonde matrix based on Om and computed normal form space
%    s = #variables
%    n = degree of thing

function V = TestGenVander( Om,N,s,n )
  A = MultIndices( s,n );
  % Standard Vandermonde
  [ Omm,Omn ] = size( Om );
  [ Am, An ] = size( A );
  
  V = zeros( Omn,An );

  for j=1:Omn
      V( j,: ) = Om( :,j )'*A;
  end
  V = exp( V ) * N;
end

