% n = degree guess
% N = # of freqs
% trials = trials
function [ avgErr,maxErr ] = TestProny( n,s,N,trials )
  avgErr = [0,0];
  maxErr1 = 0; maxErr2 = 0;

  for jN=1:trials
    [fom,Om] = GenRandomProny( N,s );
    SetOmega( fom, Om );
    [Pfom,POm] = Prony( n,s );

    % match the frequencies, build permutation

    M1 = [ Om; fom ];
    M2 = [ POm; Pfom ];

    M1 = sortrows( M1' )';
    M2 = sortrows( M2' )';

    M = M1 - M2;
    [ Mm, Mn ] = size( M );

    freqErr = M( 1:Mm-1, : );
    coErr = M( Mm,: );

    fmax = max( max (abs ( freqErr ) ) );
    cmax = max( abs( coErr ) );

    avgErr1 = sum(sum(abs(freqErr)))/(Mm*Mn);
    avgErr2 = sum(abs(coErr))/Mn;

    printf( "Frequencies: [%e/%e], Coeffs: [%e/%e] (avg/max)\n", avgErr1, fmax, avgErr2, cmax );
    
    maxErr1 = max( maxErr1, fmax );
    maxErr2 = max( maxErr2, cmax );
    avgErr = avgErr + [ avgErr1, avgErr2 ];
  end
  avgErr = avgErr / trials;
  maxErr = [ maxErr1, maxErr2 ];
end
